=== debian/changelog ===
bmdc (0.1.3) trusty; urgency=low

  * BMDC initial,

 -- FreeDC++ <freedcpp@seznam.cz>  Tue, 15 Mar 2011 20:50:35 +0100
