=== debian/control ===
Source: bmdc
Section: net
Priority: optional
Maintainer: Mank <Mank1@seznam.cz>
XSBC-Original-Maintainer: Mank <Mank1@seznam.cz>
Build-Depends: 
 cdbs (>= 0.4.85~),
 debhelper (>= 4.2.0),
 patchutils (>= 0.2.25), 
 scons,
 libbz2-dev,
 zlib1g-dev,
 libgtk-3-dev,
 libssl-dev,
 libcanberra-dev,
 libnotify-dev,
 libgeoip-dev,
 libtar-dev,
 libxss-dev,
 bzr
Homepage: http://launchpad.net/bmdc++/
Standards-Version: 3.9.2

Package: bmdc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: BMDC++ Client with Ignore User , Media Spam and many others.
 DC++ Client with Ignore User , Media Spam and many others.
 By Mank and branec ( icons)
 ...
 .
 http://freedcppmv.sourceforge.net/.
