=== debian/watch ===
version=3

https://launchpad.net/bmdc++/+download .*bmdc-(.*)\.tar\.bz2
